/* ------------------------------------------------------------------------ */
/*  Hyper Operating System V4  ITRON4.0dl Real-Time OS                  */
/*    vZbTۉR|[lg (ARM gccp)                            */
/*                                                                          */
/*                                  Copyright (C) 1998-2002 by Project HOS  */
/*                                  http://sourceforge.jp/projects/hos/     */
/* ------------------------------------------------------------------------ */

#include "pacarm.inc"

	.text

	.align	4
	.arm

	.global _HOS_IrqHandler

	.extern kernel_sta_int
	.extern kernel_end_int
	.extern kernel_exe_int

	.extern kernel_int_sp
	.extern kernel_int_ssp
	.extern kernel_int_cnt

_HOS_IrqHandler:
	mov	r3, #0x4000000
	add	r3, r3, #0x208
	ldrh	r1, [r3]		@ r1 = REG_IME
	mov	r2, #0
	strh	r2, [r3]		@ disable IME
	mrs	r0, spsr
	stmfd	sp!, {r0-r1,r3,lr}	@ {spsr, IME, REG_BASE, lr_irq}

	@ IRQ  enable / FIQ  enable / VXe[hֈڍs
	mrs	r2, cpsr
	bic	r2, r2, #0xdf
	orr	r2, r2, #0x1f
	msr	cpsr,r2

	push	{lr}

	@ d荞݂̃`FbN
	ldr	r0, =kernel_int_cnt
	ldr	r1, [r0]
	cmp	r1, #0
	add	r1, r1, #1
	str	r1, [r0]
	bne	call_intr_handler

	@ 荞ݗp̃X^bN (̂)
	ldr	r0, =kernel_int_ssp
	str	sp, [r0]		@ X^bN|C^ޔ
	ldr	r0, =kernel_int_sp
	ldr	sp, [r0]		@ 荞ݗpX^bNݒ

	@ 荞݊Jn (̂)
	bl	kernel_sta_int

call_intr_handler:
	bl	get_irq_no

	.ifdef	not_use
	@ kernel_exe_int œƂĂ̂
	mov	r2, #0x4000000
	add	r2, r2, #0x208
	mov	r1, #1
	strh	r1, [r2]		@ REG_IME = 1
	.endif

	@ 荞݃nh̎s
	bl	kernel_exe_int

	.ifdef	not_use
	@ kernel_exe_int œƂĂ̂
	mov	r3, #0x4000000		@ REG_BASE
	str	r3, [r3, #0x208]	@ disable IME
	.endif

	@ d荞݂̃`FbN
	ldr	r0, =kernel_int_cnt
	ldr	r1, [r0]
	sub	r1, r1, #1
	str	r1, [r0]
	cmp	r1, #0
	bne	ret_intr

	@ X^bN|C^̕A (̂)
	ldr	r0, =kernel_int_ssp
	ldr	sp, [r0]		@ X^bN|C^𕜋A

	@ 荞ݏI (̂)
	bl	kernel_end_int

ret_intr:
	@ IRQ ̕A
	pop	{lr}

	@ IRQ  disable / FIQ  enable / IRQ [hֈڍs
	mrs	r3, cpsr
	bic	r3, r3, #0xdf
	orr	r3, r3, #0x92
	msr	cpsr, r3

	ldmfd   sp!, {r0-r1,r3,lr}	@ {spsr, IME, REG_BASE, lr_irq}
	msr	spsr, r0		@ restore spsr
	strh	r1, [r3]		@ restore REG_IME
	mov	pc, lr


get_irq_no:
	mov	r2, #0x4000000
	ldr	r1, [r2,#0x210]		@ r1 = (REG_IE)
	ldr	r3, [r2,#0x214]		@ r3 = (REG_IF)
	and	r1, r1, r3		@ r1 = (REG_IE) & (REG_IF)

	@ r0 = INTNO
	mov	r0, #0
	ands	r3, r1, #1		@ V-blank (0)
	bne	intr1
	add	r0, r0, #1
	ands    r3, r1, #2		@ H-blank (1)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #4		@ V-counter (2)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #8		@ Timer 0 (3)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x10		@ Timer 1 (4)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x20		@ Timer 2 (5)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x40		@ Timer 3 (6)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x80		@ Serial Communication (7)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x100		@ DMA 0 (8)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x200		@ DMA 1 (9)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x400		@ DMA 2 (10)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x800		@ DMA 3 (11)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x1000		@ Key (12)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x2000		@ Cart (13)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x10000	@ IPC sync (16)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x20000	@ Send FIFO empty (17)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x40000	@ Receive FIFO empty (18)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x80000	@ Card (19)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x100000	@ Card line (20)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x200000	@ Geometry FIFO (21)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x400000	@ LID (22)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x800000	@ SPI (23)
	bne     intr1
	add	r0, r0, #1
	ands    r3, r1, #0x1000000	@ WIFI (24)
	@ bne     intr1
intr1:
	str	r1, [r2,#0x214]		@ (REG_IF) = r1
	mov	pc, lr

	.end

/* ------------------------------------------------------------------------ */
/*  Copyright (C) 1998-2002 by Project HOS                                  */
/* ------------------------------------------------------------------------ */
